<?php
/**
 * jDiction database class
 *
 * extends the current joomla database class with translation functions
 *
 * @package jDiction
 * @link http://joomla.itronic.at
 * @copyright	Copyright (C) 2011 ITronic Harald Leithner. All rights reserved.
 * @license GNU General Public License v3
 *
 * This file is part of jDiction.
 *
 * jDiction is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * jDiction is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with jDiction.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
defined('_JEXEC') or die;

require_once(JPATH_LIBRARIES.'/joomla/database/database/mysqli.php');
/**
 * MySQLi database driver
 *
 * @package		jDiction
 */
class JdDatabaseAdapter extends JDatabaseMySQLi   {

	/**
	 * This special constructor reuses the existing resource from the existing db connecton
	 *
	 * @param unknown_type $options
	 */
	public function __construct($options){
		//$db =  JFactory::getDBO();
		
		// connect to the server
		//$this->connection =  $db->getConnection();

		// finalize initialization
		parent::__construct($options);
		

		// finalize initialization
		//TODO: does this work?
		//JDatabase::__construct($options);
	}
	
	/**
	 * returns the field count of the current query
	 * @param int field count
	 */
	public function getFieldCount(){
		if ($this->cursor) {
			return $this->cursor->field_count;
		}
		return 0;
	}	
	
	/**
	 * load the field metadata from the current query
	 * @return object
	 */
	public function getFieldMetaData(){
		return $this->cursor->fetch_field();
	}
	
	protected function collectTranslationTables() {
		if (!($this->cursor instanceof MySQLi_Result)) {
			return false;
		}

		/* check if this is a select query, we can't handle any other query type atm */
		if (strpos(strtoupper($this->sql),"SELECT")===false) {		
			return false;
		}

		// get column metadata
		$fields = $this->cursor->fetch_fields();
		if (!count($fields)) {
			return false;
		}
		
		$this->jd_metadata = array();
		
		foreach($fields as $fieldid=>$field) {
			//detect table alias
			$tablealias = $field->table;
			if (isset($field->orgtable)) {
				$table = $field->orgtable;
			} else {
				$table = $field->table;
			}
			if (isset($this->tablePrefix) && strlen($this->tablePrefix)>0 && strpos($table,$this->tablePrefix)===0) {
				$table = substr($table, strlen( $this->tablePrefix));
			}
			$this->jd_metadata['tablealias'][$tablealias] = $table;
			$this->jd_metadata['tables'][$tablealias]['fields'][$fieldid] = $field;
		}
	}
	
	public function getParser() {
		require_once dirname(__FILE__).'/mysqli-parser.php';
		return new MySqliParser();
	}
	
	public function getCreator() {
		require_once dirname(__FILE__).'/mysqli-creator.php';
		return new MySqliCreator();
	}
}