<?php
/**
 * jDiction plugin
 *
 * @package jDiction
 * @link http://joomla.itronic.at
 * @copyright	Copyright (C) 2011 ITronic Harald Leithner. All rights reserved.
 * @license GNU General Public License v3
 *
 * This file is part of jDiction.
 *
 * jDiction is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 * jDiction is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with jDiction.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
defined('_JEXEC') or die;

jimport('joomla.event.plugin');

//load jdiction framework
jimport('jdiction.jdiction');

class plgSystemjDiction extends JPlugin {

	public function __construct(& $subject, $config = array()) {
		parent::__construct($subject, $config);

	}
	
	/**
	 * replace database object
	 * @return void
	 */
	public function onAfterInitialise() {
		
		$jd = jDiction::getInstance();
		$jd->initialise();
		
	}
	
	/**
	 * run after Route
	 */
	public function onAfterRoute() {
    $jd = jDiction::getInstance();
    $jd->addToolbar();
		$component = $jd->getComponent(jRequest::getCmd('option'));
	  if ($component) {
	  	if (JFactory::getApplication()->isAdmin()) {
	      JHtml::register('Grid.id', array($this, 'gridIdHook'));
		    JHtml::_('behavior.framework');
		    $doc = JFactory::getDocument();
		    $doc->addScript('/administrator/components/com_jdiction/assets/jdiction.js');
		  }
		}
	}
	
	public function gridIdHook() {
		$row = func_get_arg(0);
		$id = func_get_arg(1);
		$vars = func_get_args();
		$res = call_user_func_array('JHtmlGrid::id', $vars);
		$jd = jdiction::getInstance();
		$component = $jd->getComponent(jRequest::getCmd('option'));
		$status = $jd->getTranslationStatus($component['__metadata']['table'], $id);
		
		//we take only the first view first layout atm
		foreach ($component as $k=>$tmpview) {
			if ($k != '__metadata') {
				$view=$k;
				foreach($tmpview as $l=>$tmplayout) {
					$layout = $l;
					break;
				}
				break;
			}
		}
			
		$link = $jd->getTranslationLink(jRequest::getCmd('option'), $view, $layout, $id, false);
		
		if ($row == 0) {
			$res .= '<script type="text/javascript">var jdiction = {}; jdiction['.$row.']={status:'.$status.',link:\''.$link.'\'};</script>';
		} else {
			$res .= '<script type="text/javascript">jdiction['.$row.']={status:'.$status.',link:\''.$link.'\'};</script>';
		}
		return $res;
	
	}
}
